import {
  select,
  json,
  geoPath,
  geoAlbersUsa,
  scaleOrdinal,
  schemeCategory10,
} from 'd3';
import { feature } from 'topojson';

const svg = select('svg');

const projection = geoAlbersUsa().scale(1000); // Adjust scale for zoom level
const pathGenerator = geoPath().projection(projection);

const colorScale = scaleOrdinal(schemeCategory10);

json(
  'https://cdn.jsdelivr.net/npm/us-atlas@3.0.0/us/10m.json',
).then((data) => {
  const states = feature(data, data.objects.states);
  svg
    .selectAll('path')
    .data(states.features)
    .enter()
    .append('path')
    .attr('class', 'states')
    .attr('fill', (d) => colorScale(d.properties.name))
    .attr('d', (d) => pathGenerator(d))
    .append('title')
    .text((d) => d.properties.name);
});
